import sys
import os
import re
def getIntervals(log,out):
        """
        By Roger Curley
        7/2/09
        Arguments:
            .log file produced my selfcal
            output file to store extracted intervals
        Purpose: extracts from .log files the time intervals that the phase data was averaged over.
        """
        fin=open(log)
        fout=open(out,'w')
        text=fin.readlines()[4:]
        for line in text:
                fout.write(line.split(" ")[0]+'\n')
        fin.close()
        fout.close()
def findMatchingIntervals(carmaIntervals,szaIntervals, **kwargs):
        """
        By Roger Curley
        7/2/09
        Arguments:
            file containing CARMA phase intervals (generated using getIntervals)
            file containing SZA phase intervals
            (optional) brief=[True/False]
        Purpose: if in brief mode, returns a boolean representing if the two sets of time intervals
            are the same. Otherwise, it returns a list of tupples containing time intervals when
            the phase intervals are the same between the two files.
        """
        if "brief" in kwargs:
                brief=True==kwargs["brief"]
        else:
                brief=False
        if brief:
                diff = os.popen("diff --brief %s %s"%(carmaIntervals,szaIntervals)).read()
                return not diff[:-1]=="Files %s and %s differ"%(carmaIntervals,szaIntervals)
        else:
                switch=False
                diff = os.popen("diff -y -W30 %s %s"%(carmaIntervals,szaIntervals)).read()
                output=[]
                for line in diff.splitlines():
                        #print line[11:]
                        if None!=re.match(r"\d\d:\d\d:\d\d\.\d",line[11:]):
                                if not switch:
                                        temp=line[11:]
                                        switch=True
                                        print "Starting at "+line[11:]
                        elif switch:
                               output.append((temp,prev[:11]))
                               switch=False
                               print "Ending at "+prev[11:]
                        prev=line
                if switch:
                        output.append((temp,None))
                return output
